﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Windows.Forms;

using System.Runtime.InteropServices;


using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;



namespace lufs_genplan
{
    partial class FormRazm : Form
    {
        public FormRazm()
        {
            InitializeComponent();
            
        }

        private void BtSolut_Click(object sender, EventArgs e)
        {
            if (RbUser.Checked)
            {
                Autodesk.AutoCAD.EditorInput.Editor ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor;
                Autodesk.AutoCAD.EditorInput.PromptSelectionOptions edOpt = new Autodesk.AutoCAD.EditorInput.PromptSelectionOptions();
                Autodesk.AutoCAD.EditorInput.PromptSelectionResult edRes;
                edOpt.MessageForAdding = "Выберите объекты";
                edOpt.AllowDuplicates = false;
                Autodesk.AutoCAD.DatabaseServices.TypedValue[] selval;

                List<Autodesk.AutoCAD.DatabaseServices.TypedValue> selval_list = new List<Autodesk.AutoCAD.DatabaseServices.TypedValue>();
                selval_list.Add(new Autodesk.AutoCAD.DatabaseServices.TypedValue((int)(DxfCode.LayerName), CombobLayerUse.Text));
                
                selval = selval_list.ToArray();
                edOpt.RejectPaperspaceViewport = true;
                edOpt.RejectObjectsFromNonCurrentSpace = true;

                Autodesk.AutoCAD.EditorInput.SelectionFilter ssfilter = new Autodesk.AutoCAD.EditorInput.SelectionFilter(selval);
                edRes = ed.GetSelection(edOpt, ssfilter);

                SelectionSet sset = edRes.Value;
                if (edRes.Status == PromptStatus.OK)
                {
                    double[] res = CalcRes(sset);
                    WriteResultToExcel(res);
                }
            }
            else if (RbAll.Checked)
            {
                Autodesk.AutoCAD.EditorInput.Editor ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor;
                Autodesk.AutoCAD.EditorInput.PromptSelectionResult edRes;

                Autodesk.AutoCAD.DatabaseServices.TypedValue[] selval;

                List<Autodesk.AutoCAD.DatabaseServices.TypedValue> selval_list = new List<Autodesk.AutoCAD.DatabaseServices.TypedValue>();
                selval_list.Add(new Autodesk.AutoCAD.DatabaseServices.TypedValue((int)(DxfCode.LayerName), CombobLayerUse.Text));
                //selval_list.Add(new Autodesk.AutoCAD.DatabaseServices.TypedValue((int)(DxfCode.SymbolTableName), "ModelSpace"));
                selval = selval_list.ToArray();

                Autodesk.AutoCAD.EditorInput.SelectionFilter ssfilter = new Autodesk.AutoCAD.EditorInput.SelectionFilter(selval);

                edRes = ed.SelectAll(ssfilter);
                SelectionSet sset = edRes.Value;
                if (edRes.Status == PromptStatus.OK)
                {
                    double[] res = CalcRes(sset);
                    WriteResultToExcel(res);
                }
            }
        }
        
        private void WriteResultToExcel(double[] res)
        {
            Autodesk.AutoCAD.EditorInput.Editor ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor;
            Database db = HostApplicationServices.WorkingDatabase;
            ed.WriteMessage("\nЗапуск Excel");

            
            //Получаем путь 
            System.Reflection.Assembly asm = System.Reflection.Assembly.GetExecutingAssembly();
            string LOADER = asm.Location;
            
            string template = LOADER.Substring(0,LOADER.Length-"lufs_genplan.dll".Length);
            //ed.WriteMessage("\n->"+template);
            //Добавляем имя файла с шаблоном таблицы
            template += "Разметка.xls";
            ed.WriteMessage("\nЗагрузка шаблона -> " + template);
            try
            {

                Microsoft.Office.Interop.Excel.Application xlApp = new Microsoft.Office.Interop.Excel.Application();

                Microsoft.Office.Interop.Excel.Workbook wbTemp;
                wbTemp = xlApp.Workbooks.Open(template, Type.Missing, true, Type.Missing, Type.Missing,
                                              Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                                              Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                                              Type.Missing, Type.Missing);
                string new_file = db.Filename + ".xls";

                xlApp.Workbooks[1].SaveAs(new_file, Microsoft.Office.Interop.Excel.XlFileFormat.xlWorkbookNormal, Type.Missing, Type.Missing,
                                          false, false, Microsoft.Office.Interop.Excel.XlSaveAsAccessMode.xlNoChange,
                                          Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing);

                Microsoft.Office.Interop.Excel.Worksheet wsTemp = (Microsoft.Office.Interop.Excel.Worksheet)wbTemp.Sheets.get_Item(1);
                ed.WriteMessage("\nЗапись данных -> .");
                wsTemp.Cells.set_Item(4, 4, res[1]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(6, 4, res[2]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(7, 4, res[3]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(8, 4, res[4]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(9, 4, res[5]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(10, 4, res[6]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(11, 4, res[7]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(12, 4, res[8]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(13, 4, res[9]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(14, 4, res[10]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(15, 4, res[11]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(16, 4, res[12]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(17, 4, res[13]); ed.WriteMessage(".");

                wsTemp.Cells.set_Item(18, 5, res[14]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(19, 5, res[15]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(20, 5, res[16]); ed.WriteMessage(".");

                wsTemp.Cells.set_Item(21, 4, res[17]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(22, 4, res[18]); ed.WriteMessage(".");

                wsTemp.Cells.set_Item(23, 5, res[19]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(24, 5, res[20]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(25, 5, res[21]); ed.WriteMessage(".");

                wsTemp.Cells.set_Item(26, 4, res[22]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(27, 4, res[23]); ed.WriteMessage(".");

                wsTemp.Cells.set_Item(28, 5, res[24]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(29, 5, res[25]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(30, 5, res[26]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(31, 5, res[27]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(32, 5, res[28]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(33, 5, res[29]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(34, 5, res[30]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(35, 5, res[31]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(36, 5, res[32]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(37, 5, res[33]); ed.WriteMessage(".");
                wsTemp.Cells.set_Item(5, 4, res[34]); ed.WriteMessage(".");

                xlApp.Visible = true;
                ed.WriteMessage("\nСохранение файла -> " + db.Filename + ".xls");

                xlApp.Workbooks[1].Save();
                //xlApp.Workbooks.Close();
            }
            catch (System.Exception ex)
            { ed.WriteMessage("WriteResultToExcel() -> " + ex.ToString()); }
        }

        /*  [0]     Количество примитивов находящихся в выборе но не соответствующих параметрам по типу линиии и имени блока
         *  [1]	    Устройство разметки 1.1
            [2]	    Устройство разметки 1.2.1
            [3]	    Устройство разметки 1.2.2
            [4]	    Устройство разметки 1.3
            [5]	    Устройство разметки 1.4
            [6]	    Устройство разметки 1.5
            [7]	    Устройство разметки 1.6
            [8]	    Устройство разметки 1.7
            [9] 	Устройство разметки 1.8
            [10]	Устройство разметки 1.9
            [11]	Устройство разметки 1.10
            [12]	Устройство разметки 1.11
            [13]	Устройство разметки 1.12
            [14]	Устройство разметки 1.13    - площадь   
            [15]	Устройство разметки 1.14.1  - площадь
            [16]	Устройство разметки 1.14.2  - площадь
            [17]	Устройство разметки 1.14.3
            [18]	Устройство разметки 1.15
            [19]	Устройство разметки 1.16.1  - площадь
            [20]	Устройство разметки 1.16.2  - площадь
            [21]	Устройство разметки 1.16.3  - площадь
            [22]	Устройство разметки 1.17.1
            [23]	Устройство разметки 1.17.2
            [24]	Устр.обоз.напр.дв. по полос.- площадь
            [25]	Устройство разметки 1.19    - площадь
            [26]	Устройство разметки 1.20    - площадь
            [27]	Устройство разметки 1.21    - площадь
            [28]	Устройство разметки 1.22    - площадь
            [29]	Устройство разметки 1.23    - площадь
            [30]	Устройство разметки 1.24.1  - штук
            [31]	Устройство разметки 1.24.2  - штук
            [32]	Устройство разметки 1.24.3  - штук
            [33]	Устройство разметки 1.25    - площадь
         *  [34]	Устройство разметки 1.1 на стоянках - длина
         * */
        private double[] CalcRes(SelectionSet sset)
        {
            Database db = HostApplicationServices.WorkingDatabase;
            Autodesk.AutoCAD.EditorInput.Editor ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor;
            Transaction trans = db.TransactionManager.StartTransaction();
            try
            {
                double length_tmp = 0;
                double area_tmp = 0;
                //result is array of [35], default state = 0; error state = -1;
                double[] result = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
                foreach (ObjectId id in sset.GetObjectIds())
                {
                    {//подсчет длин и площадей для Polyline Line Arc Circle и штук для BlockReference
                        //db.

                        //LinetypeTable lt = (LinetypeTable)trans.GetObject(db.LinetypeTableId, OpenMode.ForRead);
                        DBObject selOb;
                        double scale_factor=1.0d;
                        if (CheckbMasUse.Checked) { scale_factor = (LUFS_Utils.mashtToDouble(CombobMasht.Text)); }
                        else { scale_factor = 1.0d; }

                        selOb = trans.GetObject(id, OpenMode.ForRead);
                        
                        if (selOb.GetType().Name == "Polyline")
                        {
                            length_tmp = ((Polyline)selOb).Length*scale_factor;
                            area_tmp = ((Polyline)selOb).Area*scale_factor*scale_factor;
                        }
                        else if (selOb.GetType().Name == "Line")
                        {
                            length_tmp = ((Line)selOb).Length*scale_factor;
                        }
                        else if (selOb.GetType().Name == "Arc")
                        {
                            length_tmp = ((Arc)selOb).Length*scale_factor;
                            //area_tmp = ((Arc)selOb).Area*scale_factor*scale_factor;
                        }
                        else if (selOb.GetType().Name == "Circle")
                        {
                            length_tmp = ((Circle)selOb).Circumference*scale_factor;
                            area_tmp = ((Circle)selOb).Area*scale_factor*scale_factor;
                        }
                        else if (selOb.GetType().Name == "BlockReference")
                        {
                            BlockReference t_b = (BlockReference)selOb;
                            if (t_b.Name == "1.24.1") { result[30] += 1; }
                            else if (t_b.Name == "1.24.2") { result[31] += 1; }
                            else if (t_b.Name == "1.24.3") { result[32] += 1; }
                        }
                        //Заполнение result согласно типов линий примитива
                        if (selOb.GetType().Name == "Polyline" || selOb.GetType().Name == "Line" || selOb.GetType().Name == "Arc" || selOb.GetType().Name == "Circle")
                        {
                            Curve t_c = (Curve)selOb;
                            if (t_c.Linetype == "Разметка_1_1") { result[1] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_2_1") { result[2] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_2_2") { result[3] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_3") { result[4] += (length_tmp / 2.0d); /*две паралельные линии*/}
                            else if (t_c.Linetype == "Разметка_1_4") { result[5] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_5") { result[6] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_6") { result[7] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_7") { result[8] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_8") { result[9] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_9") { result[10] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_10") { result[11] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_11") { result[12] += length_tmp; result[1] -= length_tmp; /*паралельная линиия 1.1*/}
                            else if (t_c.Linetype == "Разметка_1_12") { result[13] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_13") { result[14] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_14_1") { result[15] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_14_2") { result[16] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_14_3") { result[17] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_15") { result[18] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_16_1") { result[19] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_16_2") { result[20] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_16_3") { result[21] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_17_1") { result[22] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_17_2") { result[23] += length_tmp; }
                            else if (t_c.Linetype == "Разметка_1_18") { result[24] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_19") { result[25] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_20") { result[26] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_21") { result[27] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_22") { result[28] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_23") { result[29] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_24_1") { /*пустое условие, учтено выше [30]*/}
                            else if (t_c.Linetype == "Разметка_1_24_2") { /*пустое условие, учтено выше [31]*/}
                            else if (t_c.Linetype == "Разметка_1_24_3") { /*пустое условие, учтено выше [32]*/}
                            else if (t_c.Linetype == "Разметка_1_25") { result[33] += area_tmp; }
                            else if (t_c.Linetype == "Разметка_1_1_ст") { result[34] += length_tmp; }
                            else { result[0] += 1.0d; t_c.Highlight(); /*регистрация и подсветка неучтенных объектов на слое разметки*/}
                        }
                    }
                }
                return result;
            }
            catch (System.Exception ex)
            {
                ed.WriteMessage("BtSolut_Click() " + ex.ToString());
            }
            finally
            {
                trans.Commit();
                trans.Dispose();
                ed = null;
                db = null;
            }
            //При ошибке весь результат считается неверным. Возвращаем -1 во всех ячейках
            double[] result_error = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};
            return result_error;
        }

        private void CheckbMasUse_CheckedChanged(object sender, EventArgs e)
        {
            if (CheckbMasUse.Checked) { CombobMasht.Enabled = true; }
            else { CombobMasht.Enabled = false; }
        }
    }
}
